﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data;
using System.Data.SqlClient;


namespace SubSonicORM
{
    public static class CustomerManager
    {
        public static Customer CreateCustomer(string name, string email)
        {
            if (string.IsNullOrEmpty(name))
                throw new ArgumentNullException("name");

            if (string.IsNullOrEmpty(email))
                throw new ArgumentNullException("email");

            HowToUnitTestDB.Customer c = new HowToUnitTestDB.Customer();
            c.Name = name;
            c.Email = email;
            c.Save();

            return new Customer(c.Name, c.Email);
        }

        public static Customer CreateCustomerWithoutValidation(string name, string email)
        {
            HowToUnitTestDB.Customer c = new HowToUnitTestDB.Customer();
            c.Name = name;
            c.Email = email;
            c.Save();

            return new Customer(c.Name, c.Email);
        }

        public static Customer GetCustomer(string name)
        {
            SqlDataReader dr = (SqlDataReader)HowToUnitTestDB.Customer.FetchByParameter(HowToUnitTestDB.Customer.Columns.Name, name);

            dr.Read();
            if (!dr.HasRows)
                throw new ArgumentException("Customer Not Found");

            Customer c = new Customer();
            c.ID = dr.GetInt32(0);
            c.Name = dr.GetString(1);
            c.Email = dr.GetString(2);
            return c;
        }

        public static List<Customer> GetAllCustomers()
        {
            SqlDataReader dr = (SqlDataReader)HowToUnitTestDB.Customer.FetchAll();

            List<Customer> custs = new List<Customer>();

            while (dr.Read())
            {
                Customer c = new Customer();
                c.Name = dr.GetString(1);
                c.Email = dr.GetString(2);
                custs.Add(c);
            }

            return custs;
        }


        public static void UpdateCustomer(int customerID, Customer c)
        {
            HowToUnitTestDB.Customer dbCust = HowToUnitTestDB.Customer.FetchByID(customerID);
            dbCust.Name = c.Name;
            dbCust.Email = c.Email;
            dbCust.Save();
        }

        public static Customer GetCustomer(int id)
        {
            HowToUnitTestDB.Customer c = HowToUnitTestDB.Customer.FetchByID(id);
            Customer cu = new Customer();
            cu.ID = c.Id;
            cu.Name = c.Name;
            cu.Email = c.Email;
            return cu;
        }
    }
}
