using System; 
using System.Text; 
using System.Data;
using System.Data.SqlClient;
using System.Data.Common;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Configuration; 
using System.Xml; 
using System.Xml.Serialization;
using SubSonic; 
using SubSonic.Utilities;

namespace HowToUnitTestDB{
    public partial class SPs{
        
        /// <summary>
        /// Creates an object wrapper for the UpdateCustomer Procedure
        /// </summary>
        public static StoredProcedure UpdateCustomer(string Name, string Email)
        {
            SubSonic.StoredProcedure sp = new SubSonic.StoredProcedure("UpdateCustomer" , DataService.GetInstance("HowToUnitTest"));
        	
            sp.Command.AddParameter("@Name", Name,DbType.String);
        	    
            sp.Command.AddParameter("@Email", Email,DbType.String);
        	    
            return sp;
        }

        
        /// <summary>
        /// Creates an object wrapper for the DeleteCustomer Procedure
        /// </summary>
        public static StoredProcedure DeleteCustomer(string Name, string Email)
        {
            SubSonic.StoredProcedure sp = new SubSonic.StoredProcedure("DeleteCustomer" , DataService.GetInstance("HowToUnitTest"));
        	
            sp.Command.AddParameter("@Name", Name,DbType.String);
        	    
            sp.Command.AddParameter("@Email", Email,DbType.String);
        	    
            return sp;
        }

        
        /// <summary>
        /// Creates an object wrapper for the GetAllCustomers Procedure
        /// </summary>
        public static StoredProcedure GetAllCustomers()
        {
            SubSonic.StoredProcedure sp = new SubSonic.StoredProcedure("GetAllCustomers" , DataService.GetInstance("HowToUnitTest"));
        	
            return sp;
        }

        
        /// <summary>
        /// Creates an object wrapper for the InsertCustomer Procedure
        /// </summary>
        public static StoredProcedure InsertCustomer(string name, string email)
        {
            SubSonic.StoredProcedure sp = new SubSonic.StoredProcedure("InsertCustomer" , DataService.GetInstance("HowToUnitTest"));
        	
            sp.Command.AddParameter("@name", name,DbType.String);
        	    
            sp.Command.AddParameter("@email", email,DbType.String);
        	    
            return sp;
        }

        
        /// <summary>
        /// Creates an object wrapper for the GetCustomer Procedure
        /// </summary>
        public static StoredProcedure GetCustomer(string name)
        {
            SubSonic.StoredProcedure sp = new SubSonic.StoredProcedure("GetCustomer" , DataService.GetInstance("HowToUnitTest"));
        	
            sp.Command.AddParameter("@name", name,DbType.String);
        	    
            return sp;
        }

        
    }

    
}

